# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Mock-Quick
Version:	1.111
Release:	5.%{__distinit}%{__distvers}
Summary:	Quickly mock objects and classes, side-effect free
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/Mock-Quick
Source0:	http://cpan.metacpan.org/authors/id/E/EX/EXODIST/Mock-Quick-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(Module::Build) >= 0.42
# Module Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Exporter::Declare) >= 0.103
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Fennec::Lite) >= 0.004
BuildRequires:	perl(Path::Class)
BuildRequires:	perl(Test::Exception) >= 0.29
BuildRequires:	perl(Test::More) >= 0.88
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
Mock-Quick is here to solve the current problems with Mocking libraries.

There are a couple of Mocking libraries available on CPAN. The primary problems
with these libraries include verbose syntax, and most importantly side-effects.
Some Mocking libraries expect you to mock a specific class, and will unload it
then redefine it. This is particularly a problem if you only want to override
a class on a lexical level.

Mock-Object provides a declarative mocking interface that results in a very
concise, but clear syntax. There are separate facilities for mocking object
instances, and classes. You can quickly create an instance of an object with
custom attributes and methods. You can also quickly create an anonymous class,
optionally inheriting from another, with whatever methods you desire.

Mock-Object also provides a tool that provides an OO interface to overriding
methods in existing classes. This tool also allows for the restoration of the
original class methods. Best of all, this is a localized tool: when your
control object falls out of scope, the original class is restored.

%prep
%setup -q -n Mock-Quick-%{version}

%build
perl Build.PL --installdirs=vendor
./Build

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%{_fixperms} -c %{buildroot}

%check
./Build test

%files
%doc Changes README
%{perl_vendorlib}/Mock/
%{perl_vendorlib}/Object/
%{_mandir}/man3/Mock::Quick.3*
%{_mandir}/man3/Mock::Quick::Class.3*
%{_mandir}/man3/Mock::Quick::Method.3*
%{_mandir}/man3/Mock::Quick::Object.3*
%{_mandir}/man3/Mock::Quick::Object::Control.3*
%{_mandir}/man3/Mock::Quick::Util.3*
%{_mandir}/man3/Object::Quick.3*

%changelog
* Thu Apr 26 2018 Paul Howarth <paul@city-fan.org> - 1.111-5
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Thu May 26 2016 Paul Howarth <paul@city-fan.org> - 1.111-1
- Update to 1.111
  - Documentation fixes
- BR: perl-generators where available

* Wed Sep  2 2015 Paul Howarth <paul@city-fan.org> - 1.110-1
- Update to 1.110
  - Fix #16, overloading + compare warning

* Sat Sep  6 2014 Paul Howarth <paul@city-fan.org> - 1.108-1
- Update to 1.108
  - Fix some warnings
  - Fix some typos

* Wed Aug 14 2013 Paul Howarth <paul@city-fan.org> - 1.107-1
- Initial RPM version
